/**
 * @(#)Factory.java
 *
 * Copyright: Copyright (c) 2003 Carnegie Mellon University
 *
 * This program is Factory running or killing local Jboss server.
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;


/**
 * This class represents a factorylogic which is responsible for running or kiling
 * local Jboss server using RMI mechanism. 
 *
 * @author Junsuk Oh
 * @version 1.0
 */
public class Factory extends UnicastRemoteObject implements RIFactory {

    /**
	 * @throws RemoteException
	 */
	protected Factory() throws RemoteException {
		super();
		// TODO Auto-generated constructor stub
	}

	private static final String FACTORY_NAME = "primary";

    //running or killing local Jboss server
    public void launch(String command)
	{
    	if (command.equals("run")){
	   		Runtime runtime = Runtime.getRuntime();
   			String[] cmd = {"cmd","/c","C:\\jboss-3.2.3\\bin\\run.bat"};
  			System.out.println("Running Jboss " + FACTORY_NAME );
   			try {
   				Process p = runtime.exec(cmd);
   				BufferedReader b =new BufferedReader(new InputStreamReader(p.getInputStream()));
   				String line = null;
   				while( (line=b.readLine())!= null)
   				{
    				System.out.println(line);
   				}
   			}
   			catch(Exception e)
			{
				e.printStackTrace();
    		}
		}

   		else if (command.equals("kill")){
	   		Runtime runtime = Runtime.getRuntime();
   			String[] cmd = {"cmd","/c","C:\\jboss-3.2.3\\bin\\shutdown.bat -S"};
  			System.out.println("Killing Jboss " + FACTORY_NAME);
   			try {
   				Process p = runtime.exec(cmd);
   				BufferedReader b =new BufferedReader(new InputStreamReader(p.getInputStream()));
   				String line = null;
   				while((line=b.readLine())!= null)
   				{
    				System.out.println(line);
   				}
   			}
   			catch(Exception e)
			{
				e.printStackTrace();
    		}
		}
    }

    public static void main(String args[]) {
        // Check the number of parameters.
        if (args.length != 0) {
            System.out.println("Incorrect number of parameters");
            System.out.println("Usage: java Factory");
            System.exit(1);
        }

        try {
        	
            Factory objFactory = new Factory();
            String server = "rmi://128.2.222.50:1199/" + FACTORY_NAME;
			Naming.rebind(server, objFactory);
            System.out.println("Factory is ready to serve.");

            // Wait for user interrupt.
            System.out.println("Press Enter to terminate.");
            System.in.read();

            // Clean up and finish.
            Naming.unbind(server);
            System.out.println("leaving, bye. Press ctrl-c if the delay is too long.");
        }
        catch (Exception e) {
            // Dump the exception information for debugging.
            System.out.println("Unexpected exception");
            e.printStackTrace();
            System.exit(1);
        }
    }
}
